/****************************************Copyright (c)**************************************************                         
**
**                                 http://www.powermcu.com
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			GLCD.h
** Descriptions:		None
**
**------------------------------------------------------------------------------------------------------
** Created by:			AVRman
** Created date:		2011-3-29
** Version:				2.0
** Descriptions:		The original version
**
**------------------------------------------------------------------------------------------------------
** Modified by:			Multiclet team
** Modified date:	
** Version:
** Descriptions:		
********************************************************************************************************/

#ifndef __GLCD_H 
#define __GLCD_H

/* Includes ------------------------------------------------------------------*/
#include "stdint.h"
#include <gpio.h>

/* Private define ------------------------------------------------------------*/
#define MAX_X  240
#define MAX_Y  320  
#define MAX_XY 0x12C00

#define SPI_START   (0x70)              /* Start byte for SPI transfer        */
#define SPI_RD      (0x01)              /* WR bit 1 within start              */
#define SPI_WR      (0x00)              /* WR bit 0 within start              */
#define SPI_DATA    (0x02)              /* RS bit 1 within start byte         */
#define SPI_INDEX   (0x00)              /* RS bit 0 within start byte         */
 

#define SPI_CS_LOW    GPIOF->OUT &= (~0x8000000)
#define SPI_CS_HIGH   GPIOF->OUT |= 0x8000000

/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

/* Public function prototypes -----------------------------------------------*/

void LCD_Initializtion(void);
void LCD_DrawReactangle(uint16_t x,uint16_t y,uint16_t hight,uint16_t width,uint16_t Color);
void LCD_Clear( unsigned short Color);
void LCD_SetPoint( unsigned short Xpos, unsigned short Ypos, unsigned short point);
void LCD_DrawLine( uint16_t y0, uint16_t x0, uint16_t y1, uint16_t x1 , uint16_t color );
void GUI_Text(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint16_t Color, uint32_t bkColor,int Big);

/* Private function prototypes -----------------------------------------------*/

void delay_ms( unsigned short ms);
void LCD_Configuration(void);
unsigned char LPC17xx_SPI_SendRecvByte (unsigned char byte_s);
void LPC17xx_SPI_SendByte (unsigned char byte_s);
void LCD_WriteIndex(unsigned char index);
void LCD_WriteData( unsigned short data);
void LCD_Write_Data_Start(void);
unsigned short LCD_ReadData(void);
void LCD_WriteReg( unsigned short LCD_Reg, unsigned short LCD_RegValue);
unsigned short LCD_ReadReg( unsigned short LCD_Reg);
static void LCD_SetCursor( unsigned short Xpos, unsigned short Ypos );
void PutChar( uint16_t Xpos, uint16_t Ypos, uint8_t ASCI, uint16_t charColor, uint32_t bkColor,int Big);
void GetASCIICode(unsigned char* pBuffer,unsigned char ASCII);

#endif 

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/
