/****************************************Copyright (c)****************************************************
**                                      
**                                 http://www.powermcu.com
**
**--------------File Info---------------------------------------------------------------------------------
** File name:               TouchPanel.h
** Descriptions:            The TouchPanel application function
**
**--------------------------------------------------------------------------------------------------------
** Created by:              AVRman
** Created date:            2010-11-7
** Version:                 v1.0
** Descriptions:            The original version
**
**--------------------------------------------------------------------------------------------------------
** Modified by:             Multiclet team
** Modified date:           
** Version:                 
** Descriptions:            
**
*********************************************************************************************************/

#ifndef _TOUCHPANEL_H_
#define _TOUCHPANEL_H_

/* Includes ------------------------------------------------------------------*/
#include "stdint.h"
#include <gpio.h>

/* Private define ------------------------------------------------------------*/
/* AD channel selection command and register */
#define	CHX 	0x90 	/* channel Y+ selection command */	
#define	CHY 	0xd0	/* channel X+ selection command*/

#define TP_CS(x)  if((x)){ \
	GPIOF->DIR &= ~0xE0000; \
	GPIOF->BPS &= ~0xE0000; \
	GPIOF->OUT |= 0x10000000; \
	} \
	else{ \
	GPIOF->DIR &= ~0xE0000; \
	GPIOF->BPS |= 0xE0000; \
	GPIOF->OUT &= (~0x10000000); \
} 
 
#define ENABLE  1
#define DISABLE 0
#define Black 	0x0000


/* Public function prototypes -----------------------------------------------*/				
int TP_Init(void);
int Read_Ads(int * X,int * Y);
int TP_DrawPoint(uint16_t Xpos,uint16_t Ypos);

/* Private function prototypes -----------------------------------------------*/	
int DelayUS( unsigned int cnt);
uint8_t WR_CMD (uint8_t cmd);
int RD_AD(void);
int Read_X(void);
int Read_Y(void);
int TP_GetAdXY(int *x,int *y);


#endif

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/
