 /**
   ******************************************************************************
   *  _ _ _    _ _ _   _ _
   * |     \  /     |/     \
   * |      \/           _ _\
   * |                  /
   * |         MultiClet
   * |                  \ _ _
   * |                      /
   * |_ _ _|\/|_ _ _|\ _ _ /
   *
   * @file    uart.c 
   * @author  Команда разработчиков Мультиклет
   * @date    13-07-2015
   * @brief   Пример работы c UART по протоколу modbus rtu. Пример иллюстрирует
   *	 инициализацию и передачу пакета в режиме ведущего.
   *          
   ******************************************************************************
   * @attention
   *
   * <h2><center>&copy; COPYRIGHT(c) 2015 Multiclet corp.</center></h2>
   *
   *  ДАННЫЙ ПРИМЕР НАПИСАН ДЛЯ БЫСТРОГО ОЗНАКОМЛЕНИЯ ПОЛЬЗОВАТЕЛЯ С
   *  ВОЗМОЖНОСТЯМИ МУЛЬТИКЛЕТОЧНОГО ПРОЦЕССОРА. КОМПАНИЯ МУЛЬТИКЛЕТ НЕ НЕСЁТ
   *  ОТВЕТСТВЕННОСТИ ЗА ВОЗМОЖНЫЙ ПРЯМОЙ ИЛИ КОСВЕННЫЙ УЩЕРБ, ПРИЧИНЁННЫЙ 
   *  ИСПОЛЬЗОВАНИЕМ В ПОЛЬЗОВАТЕЛЬСКИХ ПРОДУКТАХ ИНФОРМАЦИИ, СОДЕРЖАЩЕЙСЯ
   *  В ДАННОМ ПРИМЕРЕ.
   * 
   ******************************************************************************
   */

#include "ModbusInterface.h"
#include <pll.h>


char  str [300];

void InterfaceHandler (Uart * uart){
	if(uart->MbI.State == MB_INTERFACE_STATE_RECEIVED){
		// Обработка ответа ведомого устройства	
	}
}

void main(){
	int i;
	Uart uart;
	Uart uart_slave[3];
		
	// Устанавливаем тактовую частоту 100 МГц
	mc_set_pll(0x3, 0x15, 0xc, 1);
	
	// Инициализируем таймер
	TimInit();
	
	// Инициализация структуры UART
	uart.Base = UART2;

	// скорость	
	uart.Baud = 921600;	
	// паритет: 0 - NO, 1 - EVEN, 2 - ODD
	uart.Parity = 0;	
	// Порт и маска для линии tx_en
	uart.DriverEnableBitPort = GPIOC;
	uart.DriverEnableBitMask = (1<<15);
	uart.MbI.Mode = MB_INTERFACE_MODE_MASTER;
	uart.MbI.Buff = str;
	uart.MbI.BuffSize = 300;
	uart.MbI.Handler = InterfaceHandler;		
	UartInit(&(uart),0);
	
	// Формируем пакет
	str[0] = 16; // Адрес устройства
	str[1] = 3;  // Комманда
	str[2] = 0;  // Номер регистра
	str[3] = 1;	 
	str[4] = 0;  // Количество
	str[5] = 1;
	uart.MbI.MessageLength = 6;
	UartSend(&uart);
	
    while(1);
}

