
.alias SP		15	; Указатель вершины стека
.alias BP		14	; Указатель базы функции (фрейм).

.data

.global koef

koef:
.long 0, 0

.text

.global mc_set_pll         ; функция настройки PLL

;===============================================================================
; Реализация функции, которая выполняет настройку PLL 
; Интерфейс вызова ф-ции соответствует следующему объявлению в синтаксисе Си:
;
; int mc_set_pll(unsigned char RCNT, unsigned char NCNT, unsigned char MXVCO, unsigned char Enable);
;
;===============================================================================

mc_set_pll:
    rdl #SP + 8 ;RCNT
    rdl #SP + 12 ;NCNT
en:= rdl #SP + 20 ;EN
    andl @3, 0x7
    andl @3, 0x7F
    andl @3, 0x1
    slll @3, 12
    slll @2, 15
    addl @4, @2
    addl @1, @2
    setl #16, @1
    getl 1
    wrl @1, #SP + 4 ;pll отключена
    jne @en, asm_wait_pll_lock
    je @en, [#SP]  
complete   

asm_wait_pll_lock:
    getl #17 
    getl 1 
    andl @1, @2 
    je @1, asm_wait_pll_lock 
    jne @2, asm_pll_set 
complete

asm_pll_set:
    rdl #SP + 8 ;RCNT
    rdl #SP + 12 ;NCNT
    rdl #SP + 16 ;MXVCO
    rdl #SP + 20 ;EN
    andl @4, 0x7
    andl @4, 0x7F
    andl @4, 0xF
    andl @4, 0x1
    slll @4, 12
    slll @3, 8
    slll @3, 15
    addl @6, @3
    addl @3, @2
    addl @1, @2
    setl #16, @1
    getl 0
    wrl @1, #SP + 4 ;pll включена
	jmp [#SP]
complete

.global mc_get_freq         ; функция получения текущей частоты

;===============================================================================
; Реализация функции, которая возвращает текущую частоту PLL
; Интерфейс вызова ф-ции соответствует следующему объявлению в синтаксисе Си:
;
; int mc_get_freq(unsigned int xtal_freq);
;
;===============================================================================

mc_get_freq:
reg :=      getl #16
ncnt:=      andl @reg, 0x7F ;NCNT
cond_1:=    subl @ncnt, 1
ge_2:=      gel @ncnt, 1
res_0:=     se @ncnt, 2
res_1:=     se @cond_1, 3
res_2:=     sne @ge_2, @ncnt + 4 ;@ncnt + 4 верно только для unsigned long
            orl @res_0, @res_1
n_res:=     orl @res_2, @1 ;это значение N

            slrl @reg, 8
mxvco:=     andl @1, 0xF ;MXVCO

            ltl @mxvco, 8
			andl @reg, (1<<15)
			se @1, 1
cond_jmp:=	orl @1, @3

            gel @mxvco, 8
            ltl @mxvco, 12
            andl @1, @2
k_res0:=    sne @1, 1
            gel @mxvco, 12
test:=      sne @1, @mxvco - 11
            getl 1
            slll @1, @2 
k_res1:=    sne @4, @1   
k_res:=     orl @k_res0, @k_res1 ;это значение K

            slrl @reg, 12
rcnt:=      andl @1, 0x7 ;RCNT
            ltl @1, 4
resr_0:=    sne @1, 1
            subl @rcnt, 4
resr_1:=    se @1, 2
            subl @rcnt, 5
resr_2:=    se @1, 4
            subl @rcnt, 6
resr_3:=    se @1, 8
            subl @rcnt, 7
resr_4:=    se @1, 16 
            orl @resr_0, @resr_1
            orl @resr_2, @resr_3
            orl @1, @2
r_res:=     orl @1, @resr_4 ;это значение R

            getl 8
            wrl @1, #SP + 4 ;заполняет значение для возврата на случай Fref - mxvco
            
            je @cond_jmp, push_stack
            jne @cond_jmp, [#SP]
            
            mull @r_res, @k_res ;R*K
            wrl @1, koef
            rdl #SP+8 ;xtal_freq
            mull @1, @n_res ;Fref * N
            wrl @1, koef + 4
complete  

push_stack:
    getl pop_stack
    wrl @1, #SP-24
    rdl koef+4
    wrl @1, #SP-12
    rdl koef
    wrl @1, #SP-8

    
    getl #BP
    wrl @1, #SP-4
    setl #BP, #SP-4
    setl #SP, #SP-24 
    jmp divl.crt ;(Fref*N)/(R*K)
complete

pop_stack:
    rdl #SP + 4
    wrl @1, #BP + 8
    jmp [#BP+4]
    setl #BP, [#BP]
    setl #SP, #BP+4 
complete




  
  
